#include "videodev.h"

#define min 87.45 // you have to subtracting 0.05
#define max 108.05 // you have add 0.05

float tasten_freq[] = { 0.0, 101.5, 89.1, 87.6, 94.7, 104.2, 107.8 };

void radio_mute(int fd)
{   struct video_audio vid_aud;
    if (ioctl(fd, VIDIOCGAUDIO, &vid_aud)) perror("VIDIOCGAUDIO");
    vid_aud.flags |= VIDEO_AUDIO_MUTE;
    if (ioctl(fd, VIDIOCSAUDIO, &vid_aud)) perror("VIDIOCSAUDIO");
}

void radio_unmute(int fd)
{   struct video_audio vid_aud;
    if (ioctl(fd, VIDIOCGAUDIO, &vid_aud)) perror("VIDIOCGAUDIO");
    if (vid_aud.volume == 0) vid_aud.volume = 65535;
    vid_aud.flags &= ~VIDEO_AUDIO_MUTE;
    if (ioctl(fd, VIDIOCSAUDIO, &vid_aud)) perror("VIDIOCSAUDIO");
}

static int get_freq_fact(int fd)
{   struct video_tuner tuner;
    tuner.tuner = 0;
    if (ioctl (fd, VIDIOCGTUNER, &tuner) < 0) return 16;
    if ((tuner.flags & VIDEO_TUNER_LOW) == 0) return 16;
    return 16000;
}

int radio_setfreq(int fd, float freq)
{   int ifreq = (freq+1.0/32)*get_freq_fact(fd);
    return ioctl(fd, VIDIOCSFREQ, &ifreq);
}

    int fd, taste_aktuell; 
    float freq, freq_c;
    char freq_string[7], path_rc[256];
    FILE *config_file;

    GtkWidget *frequency;

void tune_down( GtkWidget *widget, gpointer data )
{ 	freq_c = freq_c -= 0.05;
//        tasten_freq[taste_aktuell] = freq_c;    
	if (freq_c < min)
	{   freq_c = max;
	}

	else
	{   radio_unmute(fd);
	    radio_setfreq(fd, freq_c);
	    sprintf(freq_string, "%3.2f", freq_c);
	    gtk_label_set(GTK_LABEL (frequency), freq_string);
	}
}

void tune_up( GtkWidget *widget, gpointer data )
{	freq_c = freq_c += 0.05;
//        tasten_freq[taste_aktuell] = freq_c;    
	if (freq_c > max)
	{   freq_c = min; 
	}	

	else 
	{   radio_unmute(fd); 
	    radio_setfreq(fd, freq_c);
	    sprintf(freq_string, "%3.2f", freq_c);
	    gtk_label_set(GTK_LABEL (frequency), freq_string);
	}
}

void quit_mute ( GtkWidget *widget, gpointer data )
{ 	radio_mute(fd);
	gtk_main_quit();
}

void write_to_rc (void)
{       int i;
        sprintf(path_rc, "%.199s/.rico_RADIOrc", getenv("HOME"));
 	config_file = fopen(path_rc, "w+");
	fprintf (config_file, "# This is the config-file for rico_RADIO\n");
	fprintf (config_file, "[saved frequencies]\n");
        for (i=1;i<=6;	fprintf (config_file, "%d = %3.2f\n", i,tasten_freq[i]),i++);
	fclose (config_file);
        config_file = fopen(path_rc, "r");
}

void taste (int i)
{	sprintf(freq_string, "%3.2f", tasten_freq[i]);
        gtk_label_set (GTK_LABEL (frequency), freq_string);
        radio_setfreq(fd, tasten_freq[i]);
	freq_c = tasten_freq[i]; taste_aktuell = i;
}


void lade_freq(void)
{       int n;
        sprintf(path_rc, "%.199s/.rico_RADIOrc", getenv("HOME"));
        if (NULL == (config_file = fopen(path_rc, "r"))) write_to_rc();

        do
	{	fgets(path_rc,80,config_file);
		if (2 == sscanf(path_rc,"%d = %f",&n,&freq) && ((n > 0) & (n < 7))) tasten_freq[n] =  freq;
    	}
	while (!feof(config_file));
	fclose(config_file);
        write_to_rc();   
        taste(1);       
}

void stat_1 (void) { taste(1); }
void stat_2 (void) { taste(2); }
void stat_3 (void) { taste(3); }
void stat_4 (void) { taste(4); }
void stat_5 (void) { taste(5); }
void stat_6 (void) { taste(6); }