#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <asm/types.h>

#include "misc.c"
#include "options.c"

#define DEVICE "/dev/radio"              /* major=81, minor=64 */
#define ver "0.7"

int main( int argc, char *argv[] )
{   int  ifreq;
    float ffreq;

	GtkWidget *window;
	GtkWidget *exit_mute;
	GtkWidget *exit_no_mute;
	GtkWidget *downbutton; /* runter *g* (verwechsele ich stndig)*/
	GtkWidget *upbutton;

	GtkWidget *vbox;
	GtkWidget *top_box;
	GtkWidget *center_box;
        GtkWidget *bottom_box;

	GtkWidget *stat1;
	GtkWidget *stat2;
	GtkWidget *stat3;
	GtkWidget *stat4;
	GtkWidget *stat5;
	GtkWidget *stat6;

	GtkWidget *info;

	gtk_init( &argc, &argv );

	vbox = gtk_vbox_new(FALSE, 0);
	top_box = gtk_hbox_new(FALSE, 0);
 	center_box = gtk_hbox_new(TRUE, 0);
	bottom_box = gtk_hbox_new(FALSE, 0);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_uposition (window, 50, 50);
	gtk_widget_set_usize (window, 230, 80);	 
	gtk_window_set_title (GTK_WINDOW (window), ("rico_RADIO "ver));

	frequency = gtk_label_new(" ");

        stat1 = gtk_button_new_with_label( "1" );
        gtk_signal_connect( GTK_OBJECT( stat1 ), "clicked", GTK_SIGNAL_FUNC(stat_1), NULL);

	stat2 = gtk_button_new_with_label( "2" );
        gtk_signal_connect( GTK_OBJECT( stat2 ), "clicked", GTK_SIGNAL_FUNC(stat_2), NULL);

        stat3 = gtk_button_new_with_label( "3" );
        gtk_signal_connect( GTK_OBJECT( stat3 ), "clicked", GTK_SIGNAL_FUNC(stat_3), NULL);

	stat4 = gtk_button_new_with_label( "4" );
        gtk_signal_connect( GTK_OBJECT( stat4 ), "clicked", GTK_SIGNAL_FUNC(stat_4), NULL);

	stat5 = gtk_button_new_with_label( "5" );
        gtk_signal_connect( GTK_OBJECT( stat5 ), "clicked", GTK_SIGNAL_FUNC(stat_5), NULL);

	stat6 = gtk_button_new_with_label( "6" );
        gtk_signal_connect( GTK_OBJECT( stat6 ), "clicked", GTK_SIGNAL_FUNC(stat_6), NULL);

	downbutton = gtk_button_new_with_label( "<<" );
	gtk_signal_connect( GTK_OBJECT( downbutton ), "clicked", GTK_SIGNAL_FUNC(tune_down), NULL);

        exit_mute = gtk_button_new_with_label("Quit (with mute)");
        gtk_signal_connect( GTK_OBJECT( exit_mute ), "clicked", GTK_SIGNAL_FUNC(quit_mute), NULL);

	exit_no_mute = gtk_button_new_with_label("Quit (without  mute)");
        gtk_signal_connect( GTK_OBJECT( exit_no_mute ), "clicked", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);

	upbutton = gtk_button_new_with_label( ">>" );
        gtk_signal_connect( GTK_OBJECT( upbutton ), "clicked", GTK_SIGNAL_FUNC(tune_up), NULL);

	info = gtk_button_new_with_label( "..." );
        gtk_signal_connect( GTK_OBJECT( info ), "clicked", GTK_SIGNAL_FUNC(option_win), NULL);

	gtk_signal_connect_object( GTK_OBJECT( window ), "destroy", GTK_SIGNAL_FUNC(quit_mute), GTK_OBJECT( window ) );

    if (argc > 1 && 1 == sscanf(argv[1],"%f",&ffreq))
    { ifreq = (int)(ffreq * 1000000);
      ifreq += 50000;
      ifreq -= ifreq % 100000;
    }

    if (-1 == (fd = open(DEVICE, O_RDONLY)))
    { perror("open " DEVICE);
      exit(1);
    }

    radio_unmute(fd);
    lade_freq();

	gtk_box_pack_start( GTK_BOX( bottom_box ), exit_mute, TRUE, TRUE, 0 );
        gtk_box_pack_start( GTK_BOX( bottom_box ), exit_no_mute, TRUE, TRUE, 0 );

	gtk_box_pack_start( GTK_BOX( top_box ), downbutton, FALSE, TRUE, 0 );
	gtk_box_pack_start( GTK_BOX( top_box ), frequency, TRUE, TRUE, 2 );
	gtk_box_pack_start( GTK_BOX( top_box ), upbutton, FALSE, TRUE, 0 );
	gtk_box_pack_start( GTK_BOX( top_box ), info, FALSE, TRUE, 0 );

	gtk_box_pack_start( GTK_BOX( center_box ), stat1, FALSE, TRUE, 0 );
	gtk_box_pack_start( GTK_BOX( center_box ), stat2, FALSE, TRUE, 0 );
	gtk_box_pack_start( GTK_BOX( center_box ), stat3, FALSE, TRUE, 0 );
	gtk_box_pack_start( GTK_BOX( center_box ), stat4, FALSE, TRUE, 0 );
	gtk_box_pack_start( GTK_BOX( center_box ), stat5, FALSE, TRUE, 0 );
	gtk_box_pack_start( GTK_BOX( center_box ), stat6, FALSE, TRUE, 0 );

        gtk_container_add( GTK_CONTAINER( vbox ), top_box );
	gtk_container_add( GTK_CONTAINER( vbox ), center_box );
	gtk_container_add( GTK_CONTAINER( vbox ), bottom_box );

	gtk_container_add( GTK_CONTAINER( window ), vbox );

	gtk_widget_show_all(window);
        gtk_main();
    return(0);
}